/* See {msm_basic.h} */
/* Last edited on 2007-01-04 02:24:43 by stolfi */

#define msm_basic_C_COPYRIGHT \
  "Copyright  2005  by the State University of Campinas (UNICAMP)"

#include <msm_basic.h>

#include <bool.h>
#include <sign.h>
#include <jsrandom.h>
#include <jsfile.h>

#include <stdio.h>
#include <stdlib.h>
#include <values.h>
#include <assert.h>

void msm_check_malloc(char *tag)
  { 
    fprintf(stderr, "[%s]", tag);
    int N = 10; 
    char *p[N];
    int k;
    for (k = 0; k < N; k++) { p[k] = malloc(2000*(k+1)); }
    for (k = 0; k < N; k++) { free(p[k]); }
    for (k = 0; k < N; k++) { p[k] = malloc(2000*(k+1)); }
    for (k = 0; k < N; k++) { free(p[k]); }
  }

int msm_choose(int lo, int hi, double dProb)
  { int n = hi - lo;
    /* Slow and stupid solution: we simulate a random walk on the
      discrete grid {{lo..hi}{lo..hi}}, from the lower corner to a
      diagonal goal line {(hi-k,lo+k)}. The Y positon is the
      answer. */
    int x = 0, y = 0; /* Displacements from the lower corner: */
    while (x + y < n)
      { double toss = drandom();
        if ((toss -= dProb/2) < 0)
          { x++; }
        else if ((toss -= dProb/2) < 0)
          { y++; }
        else
          { x++; y++; }
      }
    /* If we went through the diagonal goal line, round Y radomly: */
    if (x + y > n)
      { assert(y > 0);
        if (drandom() < 0.5) { y--; }
      }
    return y;
  }
