#ifndef msm_basic_H
#define msm_basic_H

/* Basic types for multiscale matching of univariate signals. */
/* Last edited on 2007-01-04 02:24:31 by stolfi */

#define msm_basic_H_COPYRIGHT \
  "Copyright  2005  by the State University of Campinas (UNICAMP)"

#define _GNU_SOURCE
#include <stdio.h>
#include <bool.h>
#include <sign.h>
#include <values.h>

#define INF MAXDOUBLE

void msm_check_malloc(char *tag);
  /* A procedure that calls {malloc} and {free} several times, in order
    to test the integrity of the {malloc} heap. */

int msm_choose(int lo, int hi, double dProb);
  /* Generates a random integer in the range {lo..hi}.
    If {dProb} is zero, the result is the center {(lo+hi)/2}
    of the range, rounded randomly. As {dProb} increases,
    the distribution widens.  If {dprob} is 1.0, the 
    result is either {lo} or {hi}, each with probebility 1/2. */

#endif
